package com.github.javarch.jsf.context;

import java.io.IOException;

import javax.faces.application.ResourceHandler;
import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.filter.OncePerRequestFilter;

/**
 * Evitar processamento do filtro para requisições aos recursos das <h:outputScript>, <h:outputStylesheet> and <h:graphicImage>.
 * 
 * @author Lucas
 *
 */
public abstract class OncePerRequestFacesFilter extends OncePerRequestFilter {
	 
	@Override
	protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)
			throws ServletException, IOException {
		
		String resourcesJsfPath = request.getContextPath() + ResourceHandler.RESOURCE_IDENTIFIER;
		
		if ( request.getRequestURI().startsWith(resourcesJsfPath) ){
			// keep going...
			filterChain.doFilter(request, response);			
		} else {
			doFacesFilterInternal(request, response, filterChain);
		}
	}

	protected abstract void doFacesFilterInternal(HttpServletRequest request, 	HttpServletResponse response, FilterChain filterChain)
			throws ServletException, IOException ;
}
