package com.github.javarch.jsf;

import java.util.Locale;

import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

import junit.framework.Assert;

import org.jmock.Expectations;
import org.jmock.auto.Mock;
import org.jmock.integration.junit4.JUnitRuleMockery;
import org.jmock.lib.legacy.ClassImposteriser;
import org.junit.Rule;
import org.junit.Test;

import com.github.javarch.jsf.context.FacesContextUtils;
 
public class CurrentLocaleTest {
	
	@Rule
	public final JUnitRuleMockery ctx = new JUnitRuleMockery(){{
		setImposteriser(ClassImposteriser.INSTANCE);
	}};
	
	@Mock
	FacesContextUtils facesContextUtils;

	@Mock
	FacesContext facesContext;
	
	@Mock 
	UIViewRoot uiView;
	
	@Test
	public void test() {
		CurrentLocale instance = new CurrentLocale();
		final Locale locale = new Locale("pt-BR");
		ctx.checking( new Expectations(){{
			oneOf( facesContextUtils).getFacesContext(); will( returnValue( facesContext));
			oneOf( facesContext ).getViewRoot(); will( returnValue( uiView ));
			oneOf( uiView ).getLocale(); will( returnValue( locale ));
		}});
		
		instance.setFacesContextUtils(facesContextUtils);
		Locale result = instance.getLocale();
		
		Assert.assertEquals(locale, result);
		
	}

}
